/*
 * @autor  prof. dr Sinisa Vlajic,
 * Univerzitet u Beogradu
 * Fakultet organizacionih nauka 
 * Katedra za softversko inzenjerstvo
 * Laboratorija za softversko inzenjerstvo
 * 11.12.2017
 */

// Korisnicki zahtev ZGP01: Navedeni primer uraditi u skladu sa opstom definicijom paterna.

package ZGP01Resenje;


import java.sql.*;


public class Main {
    public static void main(String[] args) throws SQLException {
        BrokerBazePodataka bbp = new BrokerBazePodataka();
        bbp.otvoriBazu();
          
        bbp.vratiStudenta().BrojIndeksa = "124-16";
        bbp.vratiStudenta().ImeStudenta = "Milan Savic";
        bbp.ubaciSlog("Student"); 

        bbp.vratiPredmet().SifraPredmeta = 2; 
        bbp.vratiPredmet().NazivPredmeta = "Projektovanje softvera";
        bbp.ubaciSlog("Predmet"); 
    
        bbp.vratiProfesora().ImeProfesora = "Dusan Savic";
        bbp.ubaciSlog("Profesor"); 
        
        bbp.zatvoriKonekciju();
      }

    }
    

class BrokerBazePodataka 
  {  Student st;
     Predmet pr;
     Profesor prof;
     
     Connection con;
     
     BrokerBazePodataka()
     { st = new Student();
       pr = new Predmet(); 
       prof = new Profesor();     
     }     
     
     public boolean ubaciSlog(String nazivKlase)
        {   String upit;
            String vratiVrednostiAtributa = ""; 
            String ImeKlase = "";
            Statement stm;
            
            if (nazivKlase.equals("Student"))
              { ImeKlase = st.vratiImeKlase();
                vratiVrednostiAtributa = st.vratiVrednostiAtributa();
              }  

            
            if (nazivKlase.equals("Predmet"))
              { ImeKlase = pr.vratiImeKlase();
                vratiVrednostiAtributa = pr.vratiVrednostiAtributa();
              }
            
            if (nazivKlase.equals("Profesor"))
              { ImeKlase = prof.vratiImeKlase();
                vratiVrednostiAtributa = prof.vratiVrednostiAtributa();
              }
            
            
            
 
            try {  stm = con.createStatement();
                                      
                   upit = "INSERT INTO " + ImeKlase +  " VALUES (" + vratiVrednostiAtributa + ")";
                   
                   int rowcount = stm.executeUpdate(upit);
                   if (rowcount>0)
                       System.out.println("\nUspesno zapamcen slog u bazi.");
                   else
                       System.out.println("\nSlog ne postoji u bazi.");
                   stm.close();
                } catch(SQLException esql)
                    { System.out.println("\nNije uspesno zapamcen slog u bazi: " + esql); return false;}
            
            return true;
        }

public boolean otvoriBazu()
 {  String Urlbaze;
     try {  Class.forName("net.ucanaccess.jdbc.UcanaccessDriver");
            Urlbaze = "jdbc:ucanaccess://src/Databases/Fakultet.mdb";
            con = DriverManager.getConnection(Urlbaze,"","");
         } catch(ClassNotFoundException e)  { System.out.println("Drajver nije ucitan:" + e) ; return false;}
              catch(SQLException esql) { System.out.println("Greska kod konekcije:" + esql); return false;}
              catch(SecurityException ese) { System.out.println("Greska zastite:" + ese); return false;}
     System.out.println("Uspostavljena je konekcija sa bazom podataka."); return true;
 }

public void zatvoriKonekciju() throws SQLException {con.close();}

public Student vratiStudenta() {return st;}
public Predmet vratiPredmet() {return pr;}
public Profesor vratiProfesora() {return prof;}

}

 